<?php
/*
STORM is under the MIT License (MIT)

Copyright (c) 2010-2022 Agence Française Informatique http://www.afi-sa.fr

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/


abstract class Storm_FileSystem_Abstract {
  abstract public function fileExists($path);

  abstract public function fileGetContents($path);

  abstract public function fileGetSize($path);

  abstract public function filePutContents($path, $data);

  abstract public function fileAppendContents(string $path, $data) : self;

  abstract public function fileMTime(string $path);

  abstract public function directoryNamesAt($path);

  abstract public function fileNamesAt($path);

  abstract public function rename(string $from, string $to) : bool;

  abstract public function isReadable(string $path) : bool;

  abstract public function isWritable(string $path) : bool;

  abstract public function fileGetContentAsArray(string $path);

  abstract public function delete(string $path) : bool;

  abstract public function readfile(string $path);

  abstract public function mkdir($path);

  abstract public function fopen(string $filename, string $mode, bool $use_include_path=false, $context=null);

  abstract public function getcwd() :string;
}
