<?php
/*
  STORM is under the MIT License (MIT)

  Copyright (c) 2010-2025 Agence Française Informatique http://www.afi-sa.fr

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.

*/


class Storm_Update_Set
{

  protected Storm_Query_Key $_column;
  protected bool $_is_col_type_key = false;
  /** string | int | null | Zend_Db_Expr */
  protected mixed $_value;

  public function __construct($column, $value = null)
  {
    $this->_is_col_type_key = ($column instanceof Storm_Query_Key);

    $this->_column = $this->_is_col_type_key
      ? $column
      : (new Storm_Query_Key($column));
    $this->_value = $value;
  }

  public function column(): string
  {
    return $this->_column->getKey();
  }

  public function value(): mixed
  {
    return $this->_is_col_type_key
      ? $this->_column->key()
      : $this->_value;
  }

  public function toUpdate(array $model): mixed
  {
    return $this->_is_col_type_key
      ? $this->_column->valueForModel($model)
      : $this->_value;
  }
}
